package tech.nevets;

/**
 * This class tells you which grades you achieved 100%'s on
 */
public class STSearchArray {
    private static final int[] GRADES = {94, 96, 100, 97, 94, 100, 93};

    public static void main(String[] args) {
        // boolean stores flag in case no 100's were found
        boolean atLeastOne = false;
        // loops through grades, checking if each one is equal to 100
        for (int i = 0; i < GRADES.length; i++) {
            // if the grade equals 100, it displays which grade it is (using the getPlace method)
            // then it displays which subscript it's in
            // finally it sets the atLeastOne flag to true so the sorry messages does not get displayed
            if (GRADES[i] == 100) {
                System.out.println("Your " + getPlace(i + 1) + " grade (subscript " + i + ") is a 100%, good job!");
                atLeastOne = true;
            }
        }
        // if the atLeastOne flag is false, the sorry message will be displayed
        if (!atLeastOne) {
            System.out.println("Sorry, but you did not score 100% on anything :(");
        }
    }


    /**
     * I bashed my head against my keyboard until this method worked properly...
     *
     * This method takes a number and determines if it gets suffixed with 'st', 'nd', 'rd', or 'th'
     * @param index number you want suffixed with 'st', 'nd', 'rd', or 'th'
     * @return String value of # and 'st', 'nd', 'rd', or 'th'
     */
    private static String getPlace(int index) {
        // Separate number into individual digits (chars)
        char[] digits = String.valueOf(index).toCharArray();
        // Quick 'th' suffix for non-edge cases
        String nonSpecial = Integer.parseInt(String.valueOf(digits)) + "th";
        // Catches stupid 11th 12th and 13th cases
        // Ensures number is > 9
        if (digits.length > 1) {
            // Ensures the tens place is 1
            if (digits[digits.length - 2] == '1') {
                return nonSpecial;
            }
        }
        // Quick ternary operation to quickly deal with single digits
        // This String will have 1st, 2nd, or 3rd appended if necessary
        // Otherwise the switch case will return the precalculated value
        final String podiumCasesPrefix = digits.length > 1 ?
                String.valueOf(digits).substring(0, digits.length - 1) :
                "";
        // Switch case for adding the special 'st', 'nd', and 'rd' suffixes
        // Or returning the initial 'th' ending
        switch (digits[digits.length - 1]) {
            case '1' -> {
                return podiumCasesPrefix + "1st";
            }
            case '2' -> {
                return podiumCasesPrefix + "2nd";
            }
            case '3' -> {
                return podiumCasesPrefix + "3rd";
            }
            default -> {
                return nonSpecial;
            }
        }
    }
}
